TOOL.Category		= "Constraints"
TOOL.Name			= "#BoneMerge"

if CLIENT then
	language.Add("BoneMerge", "Bone Merger")
	language.Add("Tool_bonemerge_name", "Bone Merger")
	language.Add("Tool_bonemerge_desc", "Attaches props to objects using bonemerging.")
	language.Add("Tool_bonemerge_0", "Left click on the object you want to attach your prop(s) to. Reload: Remove attached items.")
	language.Add("Tool_bonemerge_1", "Now left click on the prop(s), then right click to finish.")
end

function TOOL:applyMerge()
	local tents = {}
	local i = 0
	local prp
	local prp2
	for i = 1, self:NumObjects() do
		if (self:GetEnt(i):GetClass() == "prop_effect") then
			prp = ents.Create("prop_dynamic")
			prp:SetModel(self:GetEnt(i).AttachedEntity:GetModel())
			prp:SetAngles(self:GetEnt(i).AttachedEntity:GetAngles())
			prp:SetPos(self:GetEnt(i).AttachedEntity:GetPos())
			prp:SetSkin(self:GetEnt(i).AttachedEntity:GetSkin())
			prp:Spawn()
			tents[i] = prp
			self:GetEnt(i):Remove()
		else
			tents[i] = self:GetEnt(i)
		end
	end
	if (tents[1].items == nil) then
		tents[1].items = {}
	end
	if (tents[1].itemsw == nil) then
		tents[1].itemsw = {}
	end
	local validAttachment = (tents[1]:LookupAttachment("flag") != 0) || (tents[1]:LookupAttachment("eyes") != 0) || (tents[1]:LookupAttachment("forward") != 0)
	if validAttachment || (tents[1]:LookupAttachment("head") != 0) || (tents[1]:LookupAttachment("muzzle") != 0) then
		for i = 2, self:NumObjects() do
			--Weld support.
			if (constraint.HasConstraints(tents[i])) then
				local entities = constraint.GetAllConstrainedEntities(tents[i])
				local k
				local v
				for k, v in pairs(entities) do
					if (v:GetClass() == "prop_effect") then
						prp = ents.Create("prop_dynamic")
						prp:SetModel(self:GetEnt(i).AttachedEntity:GetModel())
						prp:SetAngles(self:GetEnt(i).AttachedEntity:GetAngles())
						prp:SetPos(self:GetEnt(i).AttachedEntity:GetPos())
						prp:SetSkin(self:GetEnt(i).AttachedEntity:GetSkin())
						prp:Spawn()
						prp2 = prp
						v:Remove()
					else
						prp2 = v
					end
					prp2:SetSolid(SOLID_NONE)
					prp2:SetParent(tents[i])
					constraint.RemoveAll(prp2)
					tents[1].itemsw[k] = prp2:EntIndex()
				end
			end
			tents[i]:SetSolid(SOLID_NONE)
			tents[i]:SetParent(tents[1])
			if tents[1]:LookupAttachment("flag") != 0 then
				tents[i]:Fire("setparentattachment", "flag") --TF2
			elseif tents[1]:LookupAttachment("eyes") != 0 then
				tents[i]:Fire("setparentattachment", "eyes") --Generic.
			elseif tents[1]:LookupAttachment("head") != 0 then
				tents[i]:Fire("setparentattachment", "head") --DOD:S.
			elseif tents[1]:LookupAttachment("muzzle") != 0 then
				tents[i]:Fire("setparentattachment", "muzzle") --Vehicles.
			elseif tents[1]:LookupAttachment("forward") != 0 then
				tents[i]:Fire("setparentattachment", "forward") --CS:S.
			end
			tents[i]:AddEffects(EF_BONEMERGE)
			tents[1].items[i - 2] = tents[i]:EntIndex()
		end
		self:SetStage(0)
		self:ClearObjects()
		return true
	else
		self:SetStage(0)
		self:ClearObjects()
		for i = 1, #tents do
			if tents[i]:GetClass() == "prop_dynamic" then
				tents[i]:Remove()
			end
		end
		self:GetOwner():ChatPrint("ERROR: No known attachments on the carrier object.")
		return false
	end
end

function TOOL:LeftClick(trace)
	local ent = trace.Entity
	if ent:IsValid() then
		if ent:IsPlayer() then
			return false
		elseif ent:IsWorld() then
			if (self:NumObjects() > 1) then
				return self:applyMerge()
			else
				self:SetStage(0)
				self:ClearObjects()
			end
		elseif ent == self:GetEnt(1) then
			if (self:NumObjects() > 1) then
				return self:applyMerge()
			else
				self:SetStage(0)
				self:ClearObjects()
			end
		end
		local iNum = self:NumObjects()
		local Phys = ent:GetPhysicsObjectNum(trace.PhysicsBone)
		self:SetObject(iNum + 1, ent, trace.HitPos, Phys, trace.PhysicsBone, trace.HitNormal)
		if CLIENT then
			if (iNum > 0) then
				self:ClearObjects()
			end
			return true
		end
		if (iNum == 0) then
			self:SetStage(1)
		end
		return true
	elseif (self:NumObjects() > 1) then
		return self:applyMerge()
	end
end

function TOOL:RightClick(trace)
	if (self:NumObjects() > 1) then
		return self:applyMerge()
	end
	return false
end

function TOOL:Reload(trace)
	if trace.Entity:IsValid() and not trace.Entity:IsPlayer() and not trace.Entity:IsWorld() then
		if trace.Entity.items != nil then
			local i = 0
			for i = 0, #trace.Entity.items do
				ents.GetByIndex(trace.Entity.items[i]):Remove()
			end
			if trace.Entity.itemsw != nil then
				for i = 0, (#trace.Entity.itemsw - 1) do
					ents.GetByIndex(trace.Entity.itemsw[i]):Remove()
				end
			end
			return true
		end
	end
	return false
end